package com.woolha.jpamulticolumnjoin.controller;

import com.woolha.jpamulticolumnjoin.service.OrderService;
import java.util.UUID;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/orders")
@RequiredArgsConstructor
public class OrderController {

  private final OrderService orderService;

  @GetMapping("/{id}")
  public void fetch(@PathVariable UUID id) {
    this.orderService.fetch(id);
  }

  @GetMapping("/{id}/native-query")
  public void fetchUsingNativeQuery(@PathVariable UUID id) {
    this.orderService.fetchUsingNativeQuery(id);
  }
}
