package com.woolha.jpamulticolumnjoin.controller;

import com.woolha.jpamulticolumnjoin.service.ProductService;
import java.util.UUID;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/products")
@RequiredArgsConstructor
public class ProductController {

  private final ProductService productService;

  @GetMapping("/{id}")
  public void fetch(@PathVariable UUID id) {
    this.productService.fetch(id);
  }

  @GetMapping("/{id}/native-query")
  public void fetchUsingNativeQuery(@PathVariable UUID id) {
    this.productService.fetchUsingNativeQuery(id);
  }
}
