package com.woolha.jpamulticolumnjoin.model;

import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.JoinColumns;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;
import java.math.BigDecimal;
import java.util.UUID;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.id.uuid.UuidGenerator;

@AllArgsConstructor
@NoArgsConstructor
@Builder
@Getter
@Setter
@Entity
@Table(name = "orders")
public class Order {

  @Id
  @GeneratedValue
  @GenericGenerator(name = "UUID", type = UuidGenerator.class)
  private UUID id;

  private int quantity;

  private BigDecimal price;

  private UUID categoryId;

  private String productCode;

  /**
   * If you want to join using native query (to avoid eager fetching), this field can be removed.
   */
  @JoinColumns({
      @JoinColumn(name ="categoryId", referencedColumnName = "categoryId", insertable = false, updatable = false),
      @JoinColumn(name ="productCode", referencedColumnName = "code", insertable = false, updatable = false),
  })
  @ManyToOne(fetch = FetchType.LAZY)
  private Product product;
}
