package com.woolha.jpamulticolumnjoin.service;

import com.woolha.jpamulticolumnjoin.dto.OrderWithProductDto;
import com.woolha.jpamulticolumnjoin.model.Order;
import com.woolha.jpamulticolumnjoin.repository.OrderRepository;
import java.util.Optional;
import java.util.UUID;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;

@RequiredArgsConstructor
@Service
public class OrderService {

  private final OrderRepository orderRepository;

  public void fetch(UUID id) {
    Optional<Order> orderOptional = this.orderRepository.findById(id);

    if (orderOptional.isEmpty()) {
      System.out.println("Not found");
      return;
    }

    Order order = orderOptional.get();
    System.out.println("ID: " + order.getId());
    System.out.println("Category ID: " + order.getCategoryId());
    System.out.println("Product code: " + order.getProductCode());
    System.out.println("Quantity: " + order.getQuantity());
    System.out.println("Price: " + order.getPrice());

    // Uncomment below lines if the product entity is defined in order entity using @JoinColumns
    System.out.println("Product - ID: " + order.getProduct().getId());
    System.out.println("Product - Category ID: " + order.getProduct().getCategoryId());
    System.out.println("Product - Code: " + order.getProduct().getCode());
    System.out.println("Product - Name: " + order.getProduct().getName());
    System.out.println("Product - Price: " + order.getProduct().getPrice());
  }

  public void fetchUsingNativeQuery(UUID id) {
    Optional<OrderWithProductDto> orderOptional = this.orderRepository.findOneWithProductById(id);

    if (orderOptional.isEmpty()) {
      System.out.println("Not found");
      return;
    }

    OrderWithProductDto order = orderOptional.get();
    System.out.println("ID: " + order.getId());
    System.out.println("Category ID: " + order.getCategoryId());
    System.out.println("Product code: " + order.getProductCode());
    System.out.println("Quantity: " + order.getQuantity());
    System.out.println("Price: " + order.getPrice());

    System.out.println("Product - ID: " + order.getProduct().getId());
    System.out.println("Product - Category ID: " + order.getProduct().getCategoryId());
    System.out.println("Product - Code: " + order.getProduct().getCode());
    System.out.println("Product - Name: " + order.getProduct().getName());
    System.out.println("Product - Price: " + order.getProduct().getPrice());
  }
}
