CREATE TABLE IF NOT EXISTS public."products" (
  id            uuid            NOT NULL,
  category_id   uuid            NOT NULL,
  code          text            NOT NULL,
  name          text            NOT NULL,
  price         numeric(19, 2)  NOT NULL,
  CONSTRAINT "pk_products" PRIMARY KEY (id),
  CONSTRAINT uq_products_category_id_code UNIQUE (category_id, code)
);

CREATE TABLE IF NOT EXISTS public."orders" (
  id            uuid            NOT NULL,
  quantity      int             NOT NULL,
  price         numeric(19, 2)  NOT NULL,
  category_id   uuid            NOT NULL,
  product_code  text            NOT NULL,
  CONSTRAINT "pk_orders" PRIMARY KEY (id),
  CONSTRAINT fk_orders_category_id_product_code FOREIGN KEY(category_id, product_code) REFERENCES products(category_id, code)
);

INSERT INTO "products"(
    "id",
    "category_id",
    "code",
    "name",
    "price"
) VALUES (
    '09af2dc3-b6db-4869-b00f-9ee02ce37f71',
    'a812a592-d948-4ecb-8976-3ceaee9b97dc',
    '001',
    'Product One',
    10
);

INSERT INTO "orders"(
    "id",
    "quantity",
    "price",
    "category_id",
    "product_code"
) VALUES (
    '81b7b41c-4590-46f7-94e2-9e5786b8ba04',
    1,
    10,
    'a812a592-d948-4ecb-8976-3ceaee9b97dc',
    '001'
);

INSERT INTO "orders"(
    "id",
    "quantity",
    "price",
    "category_id",
    "product_code"
) VALUES (
    '81b7b41c-4590-46f7-94e2-9e5786b8ba05',
    2,
    20,
    'a812a592-d948-4ecb-8976-3ceaee9b97dc',
    '001'
 );
